loci.formats.gui

## Class PreviewPane

- java.lang.Object
- - java.awt.Component
  - - java.awt.Container
    - - javax.swing.JComponent
      - - javax.swing.JPanel
        - - loci.formats.gui.PreviewPane

- All Implemented Interfaces:
    java.awt.image.ImageObserver, java.awt.MenuContainer, java.beans.PropertyChangeListener, java.io.Serializable, java.lang.Runnable, java.util.EventListener, javax.accessibility.Accessible

      public class PreviewPane
      extends javax.swing.JPanel
      implements java.beans.PropertyChangeListener, java.lang.Runnable

  PreviewPane is a panel for use as a JFileChooser accessory, displaying a thumbnail for the selected image, loaded in a separate thread.
  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class javax.swing.JPanel

      `javax.swing.JPanel.AccessibleJPanel`

    - ### Nested classes/interfaces inherited from class javax.swing.JComponent

      `javax.swing.JComponent.AccessibleJComponent`

    - ### Nested classes/interfaces inherited from class java.awt.Container

      `java.awt.Container.AccessibleAWTContainer`

    - ### Nested classes/interfaces inherited from class java.awt.Component

      `java.awt.Component.AccessibleAWTComponent, java.awt.Component.BaselineResizeBehavior, java.awt.Component.BltBufferStrategy, java.awt.Component.FlipBufferStrategy`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected javax.swing.JLabel` | `formatLabel` Labels containing thumbnail and dimensional information.
    `protected java.lang.String` | `formatText`
    `protected java.lang.String` | `formatTip`
    `protected javax.swing.ImageIcon` | `icon`
    `protected javax.swing.JLabel` | `iconLabel` Labels containing thumbnail and dimensional information.
    `protected java.lang.String` | `iconText`
    `protected java.lang.String` | `iconTip`
    `protected java.lang.String` | `lastId` Last ID loaded.
    `protected java.lang.Thread` | `loader` Thumbnail loading thread.
    `protected boolean` | `loaderAlive` Flag indicating whether loader thread should keep running.
    `protected java.lang.String` | `loadId` Current ID to load.
    `private static org.slf4j.Logger` | `LOGGER`
    `protected BufferedImageReader` | `reader` Reader for use when loading thumbnails.
    `protected java.lang.Runnable` | `refresher` Method for syncing the view to the model.
    `protected javax.swing.JLabel` | `resLabel` Labels containing thumbnail and dimensional information.
    `protected java.lang.String` | `resText`
    `protected java.lang.String` | `resTip`
    `protected javax.swing.JLabel` | `typeLabel` Labels containing thumbnail and dimensional information.
    `protected java.lang.String` | `typeText`
    `protected java.lang.String` | `typeTip`
    `protected javax.swing.JLabel` | `zctLabel` Labels containing thumbnail and dimensional information.
    `protected java.lang.String` | `zctText`
    `protected java.lang.String` | `zctTip`

    - ### Fields inherited from class javax.swing.JComponent

      `listenerList, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

    - ### Fields inherited from class java.awt.Component

      `accessibleContext, BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

    - ### Fields inherited from interface java.awt.image.ImageObserver

      `ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `PreviewPane(javax.swing.JFileChooser jc)` Constructs a preview pane for the given file chooser.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `close()` Closes the underlying image reader.
    `java.awt.Dimension` | `getPreferredSize()`
    `private java.awt.image.BufferedImage` | `makeImage(java.lang.String message)` Creates a blank image with the given message painted on top (e.g., a loading or error message), matching the size of the active reader's thumbnails.
    `void` | `propertyChange(java.beans.PropertyChangeEvent e)` Property change event, to listen for when a new file is selected, or the file chooser closes.
    `void` | `run()` Thumbnail loading routine.

    - ### Methods inherited from class javax.swing.JPanel

      `getAccessibleContext, getUI, getUIClassID, paramString, setUI, updateUI`

    - ### Methods inherited from class javax.swing.JComponent

      `addAncestorListener, addNotify, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, firePropertyChange, fireVetoableChange, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBaseline, getBaselineResizeBehavior, getBorder, getBounds, getClientProperty, getComponentGraphics, getComponentPopupMenu, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getFontMetrics, getGraphics, getHeight, getInheritsPopupMenu, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPopupLocation, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getTransferHandler, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, hide, isDoubleBuffered, isLightweightComponent, isManagingFocus, isOpaque, isOptimizedDrawingEnabled, isPaintingForPrint, isPaintingOrigin, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paint, paintBorder, paintChildren, paintComponent, paintImmediately, paintImmediately, print, printAll, printBorder, printChildren, printComponent, processComponentKeyEvent, processKeyBinding, processKeyEvent, processMouseEvent, processMouseMotionEvent, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeNotify, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setComponentPopupMenu, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setEnabled, setFocusTraversalKeys, setFont, setForeground, setInheritsPopupMenu, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setUI, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update`

    - ### Methods inherited from class java.awt.Container

      `add, add, add, add, add, addContainerListener, addImpl, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, getMousePosition, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, processContainerEvent, processEvent, remove, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusCycleRoot, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setLayout, transferFocusDownCycle, validate, validateTree`

    - ### Methods inherited from class java.awt.Component

      `action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, createImage, createImage, createVolatileImage, createVolatileImage, disableEvents, dispatchEvent, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPeer, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hasFocus, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, resize, resize, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setName, setSize, setSize, show, show, size, toString, transferFocus, transferFocusBackward, transferFocusUpCycle`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### LOGGER

          private static final org.slf4j.Logger LOGGER

    - #### reader

          protected BufferedImageReader reader

      Reader for use when loading thumbnails.

    - #### loadId

          protected java.lang.String loadId

      Current ID to load.

    - #### lastId

          protected java.lang.String lastId

      Last ID loaded.

    - #### loader

          protected java.lang.Thread loader

      Thumbnail loading thread.

    - #### loaderAlive

          protected boolean loaderAlive

      Flag indicating whether loader thread should keep running.

    - #### refresher

          protected java.lang.Runnable refresher

      Method for syncing the view to the model.

    - #### iconLabel

          protected javax.swing.JLabel iconLabel

      Labels containing thumbnail and dimensional information.

    - #### formatLabel

          protected javax.swing.JLabel formatLabel

      Labels containing thumbnail and dimensional information.

    - #### resLabel

          protected javax.swing.JLabel resLabel

      Labels containing thumbnail and dimensional information.

    - #### zctLabel

          protected javax.swing.JLabel zctLabel

      Labels containing thumbnail and dimensional information.

    - #### typeLabel

          protected javax.swing.JLabel typeLabel

      Labels containing thumbnail and dimensional information.

    - #### icon

          protected javax.swing.ImageIcon icon

    - #### iconText

          protected java.lang.String iconText

    - #### formatText

          protected java.lang.String formatText

    - #### resText

          protected java.lang.String resText

    - #### zctText

          protected java.lang.String zctText

    - #### typeText

          protected java.lang.String typeText

    - #### iconTip

          protected java.lang.String iconTip

    - #### formatTip

          protected java.lang.String formatTip

    - #### resTip

          protected java.lang.String resTip

    - #### zctTip

          protected java.lang.String zctTip

    - #### typeTip

          protected java.lang.String typeTip

  - ### Constructor Detail

    - #### PreviewPane

          public PreviewPane(javax.swing.JFileChooser jc)

      Constructs a preview pane for the given file chooser.

  - ### Method Detail

    - #### getPreferredSize

          public java.awt.Dimension getPreferredSize()

      Overrides:
        `getPreferredSize` in class `javax.swing.JComponent`

    - #### propertyChange

          public void propertyChange(java.beans.PropertyChangeEvent e)

      Property change event, to listen for when a new file is selected, or the file chooser closes.
      Specified by:
        `propertyChange` in interface `java.beans.PropertyChangeListener`

    - #### run

          public void run()

      Thumbnail loading routine.
      Specified by:
        `run` in interface `java.lang.Runnable`

    - #### close

          public void close()
                     throws java.io.IOException

      Closes the underlying image reader.
      Throws:
        `java.io.IOException`

    - #### makeImage

          private java.awt.image.BufferedImage makeImage(java.lang.String message)

      Creates a blank image with the given message painted on top (e.g., a loading or error message), matching the size of the active reader's thumbnails.

Copyright © 2026 Open Microscopy Environment